#include <QtGui>
#include <QtSql>
#include <QApplication>
#include <QTextCodec>
#include <QDir>
#include <QMessageBox>
#include <QLocale>
#ifdef HAVE_ANDROID
#include <QtAndroidExtras/QtAndroidExtras>
#endif

#include "form1.h"

int main(int argc, char *argv[]){
    QApplication app(argc, argv);

    QDir::setCurrent(QApplication::applicationDirPath());

    //QFontDatabase::addApplicationFont(":fonts/EndlessShowroom.ttf");
    //QFontDatabase::addApplicationFont(":fonts/FreeSans.ttf");
    //QFontDatabase::addApplicationFont(":fonts/tahoma.ttf");

    #ifndef HAVE_QT5
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF8"));
    QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF8"));
    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF8"));

    QApplication::setStyle(new QCleanlooksStyle);
    #endif

    qsrand(QTime(0,0,0).secsTo(QTime::currentTime()));


    // Специально для mageia
#ifdef _ONLYRUSSIAN
    QString locale = QLocale::system().name();
    if (locale != "ru_RU"){
        QMessageBox msgBox;
        msgBox.setWindowTitle("Warning");
        msgBox.setText("Program million does not support non-Russian languages.\nPress Close button for exit from program.\nPress Continue button for continue program with Russian.");
        msgBox.addButton("Continue", QMessageBox::AcceptRole);
        msgBox.addButton("Close", QMessageBox::RejectRole);
        msgBox.setIcon(QMessageBox::Question);
        if (msgBox.exec()==QMessageBox::RejectRole){
            return 1;
        }
    }
#endif


#ifndef __ANDROID__
    // Инизиализация звука
    SDL_Init(SDL_INIT_AUDIO);
    if(Mix_OpenAudio(22050, AUDIO_S16, 2, 1024)) {
        QMessageBox::warning(NULL,"No Sound","Unable to open audio!");
        exit(1);
    }
    // громкость
    Mix_VolumeMusic(50);
#endif

QString gameDataPath="";

#ifndef __ANDROID__
    if (QFile("million.db").exists()) {
        gameDataPath = "";
    }
    else if (QFile("/usr/share/million/million.db").exists()) {
        gameDataPath = "/usr/share/million/";
    }
    else {
        QMessageBox::critical(NULL,"Error","Unable to find game database");
        return 1;
    }
#endif

QString PathToDB = gameDataPath+"million.db";


#ifdef __ANDROID__
    QAndroidJniObject mediaDir = QAndroidJniObject::callStaticObjectMethod("android/os/Environment", "getExternalStorageDirectory", "()Ljava/io/File;");
    QAndroidJniObject mediaPath = mediaDir.callObjectMethod( "getAbsolutePath", "()Ljava/lang/String;" );

    PathToDB=mediaPath.toString()+"/Android/data/org.qtproject.example.million/million.db";

    QFile file(PathToDB);
    if (file.exists()==false){
        QDir dir;
        dir.mkpath(mediaPath.toString()+"/Android/data/org.qtproject.example.million/");
        QFile::copy("assets:/databases/million.db",PathToDB);
        //QFile::copy(":/resources/databases/million.db",PathToDB);
    }
#endif


    // Инициализация БД
    //create table question (id INTEGER PRIMARY KEY    AUTOINCREMENT, question text,a varchar(32),b varchar(32),c varchar(32),d varchar(32),level int   )
    QSqlDatabase db = QSqlDatabase::addDatabase("QSQLITE");
    db.setDatabaseName(PathToDB);
    if (!db.open()) {
        QMessageBox::critical(NULL,"Error","Unable to establish a database connection");
        return 1;
    }


    form1 form;
    form.show();

    return app.exec();
}
