#ifndef WGAME_H
#define WGAME_H

#include <QWidget>
#include <QtGui>
#include "wScore.h"
#include "wTablo.h"
#include "wButton.h"
#include "MButton.h"
#include <QSignalMapper>

#include <QtSql>
#ifndef __ANDROID__
#include <SDL.h>
#include <SDL_mixer.h>
#endif

class wGame : public QWidget {
Q_OBJECT
    public:
        wGame(QWidget *parent = 0);
        void initGame();

    private:
        void genQuestion(int level);
        void initButton();
        void initSound();

        QSignalMapper *signalMapper;

        wButton *anwser[5];
        MButton *question;
        MButton *btnClose;

        MButton *help_50;
        MButton *help_help;
        MButton *help_phone;

        QTimer *timer;
        QTimer *timer_pause;

        int is_help_50;
        int is_help_help;
        int is_help_phone;

        wScore * score_table;
        int score;

        wTablo *tablo;      // табло

        int isWait;   // датчик ожидания компьютера

        int anwserW;        // номер правильного ответа
        QString answerWstr; // Правильный ответ (string)
        int anwserCheck;    // С каким сравнивать ответ

#ifndef __ANDROID__
        Mix_Chunk *sound_fon[4];   // звуковой фон
        Mix_Music *sound_start;    // Новая несгораемая сумма
        Mix_Music *sound_pause;    // сделанный выбор
        Mix_Music *sound_true;     // ответ правильный
        Mix_Music *sound_false;    // ответ не правильный
        Mix_Music *sound_50;       // 50x50
        Mix_Music *sound_phone;       // phone
        Mix_Music *sound_help;       // help
        Mix_Music *sound_win;     // Мелодия победы
#endif

    public slots:
        void clickAnwser(int value);
        void continueGame();
        void continueGame2();
        void click_closeGames();
        void help50();
        void helpHelp();
        void helpPhone();

    signals:
        void closeGames();

};

#endif // WGAME_H
